"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlSlider = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var react_2 = require("embla-carousel/react");
var theme_1 = require("./theme");
var theme_2 = require("./theme");
var useCallbackFactory_1 = require("powerhooks/useCallbackFactory");
var useConstCallback_1 = require("powerhooks/useConstCallback");
var useEvt_1 = require("evt/hooks/useEvt");
var evt_1 = require("evt");
var useIntersectionObserver_1 = require("./tools/useIntersectionObserver");
exports.GlSlider = (0, react_1.memo)(function (props) {
    var className = props.className, slides = props.slides, title = props.title, autoPlayTimeInterval = props.autoPlayTimeInterval, width = props.width;
    var _a = __read((0, react_2.useEmblaCarousel)({ "loop": true }), 2), emblaRef = _a[0], emblaApi = _a[1];
    var _b = __read((0, react_1.useState)(false), 2), isPlaying = _b[0], setIsPlaying = _b[1];
    var interval = (0, react_1.useRef)();
    (0, useEvt_1.useEvt)(function (ctx) {
        if (autoPlayTimeInterval === undefined) {
            return;
        }
        new Map([
            ["blur", false],
            ["focus", true],
        ]).forEach(function (value, key) {
            evt_1.Evt.from(ctx, window, key).attach(function () {
                setIsPlaying(value);
            });
        });
    }, []);
    (0, react_1.useEffect)(function () {
        if (autoPlayTimeInterval === undefined ||
            autoPlayTimeInterval === 0 ||
            emblaApi === undefined) {
            return;
        }
        if (!isPlaying) {
            if (interval.current !== undefined) {
                clearInterval(interval.current);
            }
            return;
        }
        interval.current = setInterval(function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                emblaApi.scrollNext();
                return [2 /*return*/];
            });
        }); }, autoPlayTimeInterval * 1000);
    }, [autoPlayTimeInterval, emblaApi, isPlaying]);
    var ref = (0, useIntersectionObserver_1.useIntersectionObserver)({
        "callback": (0, useConstCallback_1.useConstCallback)(function (_a) {
            var entry = _a.entry, observer = _a.observer;
            if (autoPlayTimeInterval === undefined ||
                autoPlayTimeInterval === 0) {
                observer.unobserve(entry.target);
                return;
            }
            setIsPlaying(entry.isIntersecting);
        }),
    }).ref;
    var onClickFactory = (0, useCallbackFactory_1.useCallbackFactory)(function (_a) {
        var _b = __read(_a, 1), direction = _b[0];
        if (emblaApi === undefined) {
            return;
        }
        if (autoPlayTimeInterval !== undefined) {
            setIsPlaying(false);
        }
        switch (direction) {
            case "left":
                emblaApi.scrollPrev();
                break;
            case "right":
                emblaApi.scrollNext();
        }
    });
    var onMouseDown = (0, useConstCallback_1.useConstCallback)(function () {
        setIsPlaying(false);
    });
    var _c = useStyles({
        width: width,
    }, { props: props }), classes = _c.classes, cx = _c.cx;
    return ((0, jsx_runtime_1.jsxs)("section", __assign({ ref: ref, className: cx(classes.root, className) }, { children: [title !== undefined && ((0, jsx_runtime_1.jsx)(theme_1.Text, __assign({ className: classes.heading, typo: "page heading" }, { children: title }))), (0, jsx_runtime_1.jsxs)("div", __assign({ className: classes.sliderWrapper }, { children: [(0, jsx_runtime_1.jsx)(theme_2.Icon, { iconId: "arrowBackIos", className: classes.arrows, onClick: onClickFactory("left") }), (0, jsx_runtime_1.jsx)("div", __assign({ className: classes.viewport, ref: emblaRef }, { children: (0, jsx_runtime_1.jsx)("div", __assign({ className: classes.container }, { children: slides !== undefined &&
                                slides.map(function (slide, index) { return ((0, jsx_runtime_1.jsx)("div", __assign({ onMouseDown: onMouseDown, className: classes.slide }, { children: slide }), index)); }) })) })), (0, jsx_runtime_1.jsx)(theme_2.Icon, { iconId: "arrowForwardIos", className: classes.arrows, onClick: onClickFactory("right") })] }))] })));
});
var useStyles = (0, theme_1.makeStyles)({ "name": { GlSlider: exports.GlSlider } })(function (theme, _a) {
    var width = _a.width;
    return ({
        "root": __assign(__assign({}, theme.spacing.rightLeft("padding", "".concat(theme.paddingRightLeft, "px"))), theme.spacing.topBottom("margin", "".concat(theme.spacing(7), "px"))),
        "heading": {
            "marginBottom": theme.spacing(7),
            "textAlign": "center",
        },
        "sliderWrapper": {
            "display": "flex",
            "alignItems": "center",
            "justifyContent": "center",
            "width": width !== null && width !== void 0 ? width : "100%",
        },
        "viewport": {
            "overflow": "hidden",
            "userSelect": "none",
        },
        "container": {
            "display": "flex",
            "alignItems": "center",
        },
        "arrows": {
            "transition": "transform 300ms",
            ":hover": {
                "transform": "scale(1.2)",
            },
        },
        "slide": {
            "minWidth": "100%",
            "display": "flex",
            "justifyContent": "center",
            "overflow": "hidden",
            "padding": theme.spacing({
                "rightLeft": 4,
                "topBottom": 4,
            }),
        },
        "prev": {},
        "next": {},
    });
});
//# sourceMappingURL=GlSlider.js.map