import type { Source } from "./Source";
import type { ReactComponent } from "./ReactComponent";
export declare type IllustrationProps = IllustrationProps.Image | IllustrationProps.Video | IllustrationProps.CustomComponent;
declare namespace IllustrationProps {
    type Image = {
        type: "image";
        sources?: Source[];
        src: string;
        hasShadow?: boolean;
    };
    type Video = {
        type: "video";
        sources: Source[];
        hasShadow?: boolean;
        autoPlay?: boolean;
        muted?: boolean;
        loop?: boolean;
        controls?: boolean;
    };
    type CustomComponent = {
        type: "custom component";
        Component: ReactComponent<{
            className: string;
            onLoad: () => void;
            id: string;
        }>;
    };
}
export {};
